From 92b100ca250a67cbb728f04088df336411b63c77 Mon Sep 17 00:00:00 2001
From: Smeulf <smeulf@team-mediaportal.com>
Date: Sun, 19 Feb 2012 12:30:59 +0100
Subject: [PATCH 1/2] Expand ViedoPlayer to grab chapters names from
 IAMExtendSeecking

---
 .../Source/UI/Players/VideoPlayer/VideoPlayer.cs   |   20 +++++++++++++++++---
 1 files changed, 17 insertions(+), 3 deletions(-)

diff --git a/MediaPortal/Source/UI/Players/VideoPlayer/VideoPlayer.cs b/MediaPortal/Source/UI/Players/VideoPlayer/VideoPlayer.cs
index 58f220f..25a2ea1 100644
--- a/MediaPortal/Source/UI/Players/VideoPlayer/VideoPlayer.cs
+++ b/MediaPortal/Source/UI/Players/VideoPlayer/VideoPlayer.cs
@@ -1095,7 +1095,7 @@ namespace MediaPortal.UI.Players.Video
                 double markerTime;
                 extendSeeking.GetMarkerTime(i, out markerTime);
                 _chapterTimestamps[i - 1] = markerTime;
-                _chapterNames[i - 1] = GetChapterName(i);
+                _chapterNames[i - 1] = GetChapterName(i,_graphBuilder);
               }
             }
           }
@@ -1481,10 +1481,24 @@ namespace MediaPortal.UI.Players.Video
     /// </summary>
     /// <param name="chapterNumber">0 based chapter number.</param>
     /// <returns>Localized chapter name.</returns>
-    protected static string GetChapterName(int chapterNumber)
+    protected static string GetChapterName(int chapterNumber, IGraphBuilder graphBuilder=null)
     {
       //Idea: we could scrape chapter names and store them in MediaAspects. When they are available, return the full names here.
-      return ServiceRegistration.Get<ILocalization>().ToString(RES_PLAYBACK_CHAPTER, chapterNumber);
+      string markerName=null;
+      if (graphBuilder != null)
+      {
+        IAMExtendedSeeking extendSeeking = FilterGraphTools.FindFilterByInterface<IAMExtendedSeeking>(graphBuilder);
+        if (extendSeeking != null)
+        {
+          //Get the chapter name from the IAMExtendSeecking interface, if exists
+          extendSeeking.GetMarkerName(chapterNumber, out markerName);
+        }
+      }
+
+      if (!String.IsNullOrEmpty(markerName))
+        return markerName;
+      else
+        return ServiceRegistration.Get<ILocalization>().ToString(RES_PLAYBACK_CHAPTER, chapterNumber);
     }
 
     #endregion
-- 
1.7.6.msysgit.0

